﻿/* 
 * ----------------------------------------------------------------------------
 *
 *   Hatene::Bookmark Plugin for Google Desktop.
 *
 *  Copyright (c) 2005, Tennetiss
 *  http://www.akaiho.com/
 *
 *  Thing I want say about this code is that, 
 *  the Del.icio.us plugin code is used as a useful reference.
 *  Thanks Manas, I appreciate it.
 *
 *  CHANGELOG:
 *    2005-12-20  :  initially setup
 *    2005-12-23  :  revised some Japanese sentences to English
 *    2006-01-01  :  put a button to reset the user ID
 *    2006-04-01  :  user can set the time interval
 *                :  able to use alert popup for new coming bookmark
 *                :  fetch the # of users who bookmarks each site
 *    2006-05-05  :  fetches multiple tags
 *    2006-05-15  :  bug fixed for GD4 beta
 *    2006-08-29  :  deploy "coming up bookmark" feature
 *    2006-11-29  :  refactored for GD ver4, and changed to utf8
 *
 * ----------------------------------------------------------------------------
 */

var kCurrentVersion = "1.55";
var kUpdatesUri = "http://www.akaiho.com/projects/hatenabookmarkplugin";
var kProductHomePageUri = "http://www.akaiho.com/projects/hatenabookmarkplugin";

var kHatenaUsernameTemplate = "http://b.hatena.ne.jp/{user}?mode=rss";
var kHatenaUsernameDef = "http://b.hatena.ne.jp/{user}/rss";
var kHatenaAttentionUri = "http://b.hatena.ne.jp/entrylist?mode=rss&sort=hot&threshold=3";
var kHatenaHotentryUri = "http://b.hatena.ne.jp/hotentry?mode=rss";

var kBookmark;
var kDefaultKind = listsHotentry;
var kDefaultUsername = "hotentry";
var kCheckIntervalMs;
var kMaxBookmarks = 1000;
var kDefaultScoreForNewItem = 10000; // so new items appear at the top.
var kMaxScoreLimit = 1000000; // 
var kGetCountUri = "http://b.hatena.ne.jp/xmlrpc";

var kgetCountParametersHeader = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
kgetCountParametersHeader += "<methodCall>\n<methodName>bookmark.getCount</methodName>\n<params>\n";

var kgetCountParametersFooter = "</params></methodCall>";

// Represents indexes inside a comma-separated value stored in options:
var kPropertyCount = 2; // how many props per url?
var kMetaDataIndex_Score = 0;
var kMetaDataIndex_Pinned = 1;

var timerId = null;
var http = null;
var http2 = null;
var contentItems = new Array();
var bookmarkCount = new Array();

function Main() {
  SetDefaultOptions();

  bookmark.pinImages = new Array(
    framework.graphics.loadImage("tag_n.gif"),
    framework.graphics.loadImage("tag_blue1.gif"),
    framework.graphics.loadImage("tag_blue_edit.gif"));
  bookmark.contentFlags = gddContentFlagNone | gddContentFlagPinnable | gddContentFlagHaveDetails;
  bookmark.maxContentItems = kMaxBookmarks;

  pluginHelper.onAddCustomMenuItems = AddCustomMenuItems;
  pluginHelper.onShowOptionsDlg = ShowOptionsDlg;

  kBookmark = options.GetValue("Bookmarkkind");
  ResetTimeInterval(options.GetValue("Timeinterval"));
//  utils.setInterval(RefreshDisplay, kCheckIntervalMs);
  RefreshDisplay();
}

function view_onopen(){
  Main();
}

function SetDefaultOptions() {
  options.defaultValue("Bookmarkkind") = kDefaultKind;
  options.defaultValue("Username") = kDefaultUsername;
  options.defaultValue("Timeinterval") = "60";
}

function ResetTimeInterval(newIntervalmin){
  kCheckIntervalMs = 1000 * 60 * newIntervalmin;
  if(timerId != null) { view.clearInterval(timerId); }
  timerId = view.setInterval(RefreshDisplay, kCheckIntervalMs);
}

function AddCustomMenuItems(menu) {
  menu.AddItem(refreshMenu, 0, RefreshDisplay);
}

function CheckForUpdates() {
}

function PostRefreshTasks() {
//  CheckForUpdates();
}

function RefreshDisplay() {
  var url = null;

  if( kBookmark == listsHotentry ){
    url = kHatenaHotentryUri;
  }
  else if( kBookmark == listsAttention ){
    url = kHatenaAttentionUri;
  }
  else if( kBookmark == listsHatenaid ){
    if (options.GetValue("Username") == "hotentry") {
	  url = kHatenaUsernameTemplate.replace(/\{user\}/g, options.GetValue("Username"));
    }
    else {
      url = kHatenaUsernameDef.replace(/\{user\}/g, options.GetValue("Username"));
    }
  }
  http = new XMLHttpRequest();
  http.onreadystatechange = OnReceivedData;
  // http.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
//  http.open("GET", url + "?noCache=" + Math.random(), true);
  http.open("GET", url, true);
  try {
    http.send();
  }
  catch(e) {
    // Just in case ... not that we expect something bad to happen here.
  }
}

function OnReceivedData() {
  if (http && http.readyState == 4) { // completed OK?
    // make array empty.
    for (var i = 0; i < contentItems.length; ++i) {
      contentItems[i] = null; // dereference each element.
    }
    contentItems.splice(0, contentItems.length);

    // Parse and add each bookmark to our array.
    var doc = new DOMDocument();
    doc.loadXML(http.responseText);

    var title, url, tags, date;
    tags = "";
    var elem = doc.getElementsByTagName("item");
    if (elem != null && elem.length > 0) {
      for(var i = 0; i < elem.length; ++i) {
        for (var node = elem[i].firstChild; node != null;
            node = node.nextSibling) {
          if (node.nodeName == "title")
            title = node.firstChild.nodeValue;
          else if (node.nodeName == "link")
            url = node.firstChild.nodeValue;
          else if (node.nodeName == "dc:subject"){
            if(node.firstChild != null){
              if(tags != ""){ tags += ","; }
              tags += node.firstChild.nodeValue;
            }
          }
          else if (node.nodeName == "dc:date")
            date = node.firstChild.nodeValue;
        }

        if (title != null) {  // successfully parsed?
          var bookmarkItem = new BookmarkItem(title, url, tags, date);
          contentItems.push(bookmarkItem);
        }
        tags = "";
      }
      getBookmarkCount( contentItems );
    }

    // http = null;
    contentItems = contentItems.reverse();
    contentItems.sort(BookmarkItemSort);
    bookmark.removeAllContentItems();

//     utils.alert("Adding : " + contentItems.length + " items.");
    for (var i = 0; i < contentItems.length; ++i) {
      contentItems[i].AddToSidebar();
    }

    PostRefreshTasks();
  }
}

function getBookmarkCount( items ) {
  var url = kGetCountUri;
  http2 = new XMLHttpRequest();
  http2.onreadystatechange = OnReceivedgetCount;
  var sendingData = kgetCountParametersHeader;
  for( var i=0; i< items.length; i++ ){
    if(items[i].item.source.search(/&/g) == -1){
      // if there's a letter "&" inside the uri string, the api returns an error
      sendingData += "<param><value><string>" + items[i].item.source + "</string></value></param>\n";
    }
  }
  sendingData += kgetCountParametersFooter;
  
  http2.open("POST", url, false);
  http2.setRequestHeader('Content-Type', 'application/xml');
  try {
    http2.send(sendingData);
  }
  catch(e) {
    // Just in case ... not that we expect something bad to happen here.
  }
}


function OnReceivedgetCount() {
  if (http2 && http2.readyState == 4) { // completed OK?

    // Parse and add each bookmark to our array.
    var doc = new DOMDocument();
    doc.loadXML(http2.responseText);
//    utils.alert(http2.responseText);

    var uri, count;
    var elem = doc.getElementsByTagName("member");
    if (elem != null && elem.length > 0) {
      for(var i = 0; i < elem.length; ++i) {
        for (var node = elem[i].firstChild; node != null;
            node = node.nextSibling) {
          if (node.nodeName == "name")
            uri = node.firstChild.nodeValue;
          if (node.nodeName == "value"){
            if(node.firstChild.nodeName == "int"){
              count = node.firstChild.firstChild.nodeValue;
            }
          }
        }

        if (uri != null) {  // successfully parsed?
          for( var j=0; j < contentItems.length; j++ ){
            if(contentItems[j].item.source == uri){
              contentItems[j].AddCount( count );
              break;
            }
          }
        }
      }
    }
  }
}


function BookmarkItemSort(a, b) {
  // if both are pinned or both are unpinned, sort by click frequency.
  // if either is pinned, that ranks higher, irrespective of click frequency.
  if (a.IsPinned()) {
    if (b.IsPinned()) {
      return a.GetScore() - b.GetScore();
    } else {
      return +1;
    }
  } else {
    if (b.IsPinned()) {
      return -1;
    } else {
      return a.GetScore() - b.GetScore();
    }
  }
}

// A class that encapsulates a Bookmark.
function BookmarkItem(title, url, tags, date) {
  this.item = new ContentItem();

  this.item.layout = gddContentItemLayoutNowrapItems; // gddContentItemLayoutEmail;
  this.item.heading = title;
  this.item.source = url;
  this.item.tooltip = url + "\n" + tagsTitle + " " + tags;
  this.item.snippet = options.GetValue("url:" + url);

  this.bookmarks = "";
  this.tip = url+ "\n" + tagsTitle + " " + tags;

  this.item.onDetailsView = OnOpenItem; // Open item even on single-click.
  this.item.onOpenItem = OnOpenItem; // And keep double-click behavior unchanged.
  this.item.onToggleItemPinnedState = ToggleItemPinnedState;

  // Initialize metadata for new bookmarks.
  if ("" == options.GetValue("url:" + this.item.source)) {
    // Set a default score, so new bookmark shows up at the top.
    options.PutValue("url:" + this.item.source, kDefaultScoreForNewItem + ",unpinned");
  }

  // Methods.

  BookmarkItem.prototype.GetScore = GetScore;
  function GetScore() {
    return parseInt(GetProperty("url:" + this.item.source, kMetaDataIndex_Score));
  }

  BookmarkItem.prototype.IsPinned = IsPinned;
  function IsPinned() {
    return ("pinned" == GetProperty("url:" + this.item.source,
        kMetaDataIndex_Pinned));
  }

  BookmarkItem.prototype.AddCount = AddCount;
  function AddCount(bookMarkcount){
    this.tip += "\n" + bookMarkcount + " users";
    this.item.tooltip = this.tip;
    this.bookmarks = bookMarkcount;
  }
  
  BookmarkItem.prototype.AddToSidebar = AddToSidebar;
  function AddToSidebar() {
//     utils.alert(this.item.source + "¥n" + options.GetValue("url:" + this.item.source));
    if( this.GetScore() < kDefaultScoreForNewItem-1 ){
      bookmark.addContentItem(this.item, gddItemDisplayInSidebar);
    }
    else if( this.GetScore() >= kDefaultScoreForNewItem-1 ){
      this.item.snippet = "" + this.bookmarks + " users";
      bookmark.addContentItem(this.item, gddItemDisplayInSidebar | gddItemDisplayAsNotification);
//      this.item.snippet = options.GetValue("url:" + this.item.url );
    }
//    pluginHelper.AddContentItem(this.item, gddItemDisplayAsNotification);
  }

  if (this.IsPinned()) {
    this.item.flags = gddContentItemFlagNoRemove | gddContentItemFlagPinned;
  } else {
    this.item.flags = gddContentItemFlagNoRemove;
  }

  var currentScore = GetProperty("url:" + this.item.source, kMetaDataIndex_Score);
  // Must age the bookmark, else new ones will always appear at the very bottom.
  if (currentScore > 0) { // don't age below "birth".
    PutProperty("url:" + this.item.source, kMetaDataIndex_Score,
        "" + (currentScore - 1));
  }

  function OnOpenItem(item) {
    // Increment score, store it as a string.
/*    var currentScore = parseInt(GetProperty("url:" + item.source,
        kMetaDataIndex_Score));
    if (currentScore < kMaxScoreLimit) {
      PutProperty("url:" + item.source, kMetaDataIndex_Score, "" + (currentScore + 1));
    }
*/
    // Since we take over the default behavior, we need to open the item ourselves.
    var wshShell = new ActiveXObject("WScript.Shell");
    wshShell.run(item.source);
    wshShell = null;
  }

  function ToggleItemPinnedState(item) {
    // Toggle pinned state.
    var wasPinned = GetProperty("url:" + item.source, kMetaDataIndex_Pinned);
    var isPinned = ("pinned" == wasPinned) ? "unpinned" : "pinned";
    PutProperty("url:" + item.source, kMetaDataIndex_Pinned, isPinned);

    // Since we take over the default behavior, we need to do the pinning ourselves.
    if ("pinned" == isPinned) {
      item.flags = gddContentItemFlagNoRemove | gddContentItemFlagPinned;
    } else {
      item.flags = gddContentItemFlagNoRemove;
    }
  }
}

function GetProperty(url, index) {
  var currValue = options.GetValue(url);
  if (currValue != "") {
    var props = currValue.split(",");
    return props[index];
  } else {
    return "";
  }
}

function PutProperty(url, index, newValue) {
  // assert (index < kPropertyCount);
  var oldValue = options.GetValue(url);
  var oldProps;
  if (oldValue != "") {
    oldProps = oldValue.split(",");
  } else {
    oldProps = new Array(kPropertyCount); // make new properties if missing.
  }
  oldProps[index] = newValue;
  options.PutValue(url, oldProps.join(","));
}

// ---- Options Dialog ----

function ShowOptionsDlg(wnd) {

  var lists = new Array( listsHotentry, listsAttention, listsHatenaid );
  if(kBookmark == listsAttention){
    lists[0] = listsAttention;
    lists[1] = listsHotentry;
  }
  else if(kBookmark == listsHatenaid){
    lists[0] = listsHatenaid;
    lists[1] = listsHotentry;
    lists[2] = listsAttention;
  }
  
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", enterBookmark,
      30, 10, 200, 15);
  wnd.AddControl(gddWndCtrlClassList, 0, "listbox", lists,
      30, 25, 200, 35);
  
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", enterHatenaUsername,
      30, 70, 320, 15);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "username", options.GetValue("Username"),
      30, 85, 150, 22);
  var defaultButton = wnd.AddControl(gddWndCtrlClassButton, 0,
      "resetUserIDButton", resetUserIDButton, 230, 85, 100, 22);

  wnd.AddControl(gddWndCtrlClassLabel, 0, "", enterTimeInterval,
                 30, 110, 200, 15);
  wnd.AddControl(gddWndCtrlClassEdit, 0, "timeinterval", options.GetValue("Timeinterval"),
                 30, 125, 150, 22);

  
  wnd.AddControl(gddWndCtrlClassLabel, 0, "", resetUsageDataDesc, 30, 150, 300, 40);
  var resetButton = wnd.AddControl(gddWndCtrlClassButton, 0,
      "resetUsageDataButton", resetUsageDataButton, 30, 200, 120, 22);
  resetButton.onClicked = OnResetButtonClicked;
  defaultButton.onClicked = OnResetUserIDButtonClicked;

  wnd.onClose = OptionsDlgClosed;
}

function OnResetButtonClicked(wnd, ctrl) {
  // Reset the scores for every item.
  for (var i = 0; i < contentItems.length; ++i) {
    PutProperty("url:" + contentItems[i].item.source, kMetaDataIndex_Score,
        "" + kDefaultScoreForNewItem);
  }
}

function OnResetUserIDButtonClicked(wnd, ctrl){
  // Reset the userID (change the ID to default)
  var currentHID = wnd.GetControl("username");
  currentHID.value = kDefaultUsername;
}

function OptionsDlgClosed(wnd, code) {
  if (code == gddIdOK) {

    var thelist = wnd.GetControl("listbox");
//    utils.alert(thelist.value);
    options.PutValue("Bookmarkkind", thelist.value);
    kBookmark = thelist.value;
    
    var username = wnd.GetControl("username");
    options.PutValue("Username", username.text);

    var timeinterval = wnd.GetControl("timeinterval");
    if( isNaN(timeinterval.text) || (timeinterval.text <= 0) ){
      utils.alert( inputTimeError );
    }
    else {
      options.PutValue("Timeinterval", timeinterval.text);
      ResetTimeInterval(timeinterval.text);
    }
    RefreshDisplay();
  }
}


  